
CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  _clkHz = 80_000_000
  _byteLimit = 100
   

VAR
  byte b_delimiter
  byte b_waitingToBeParsed[_byteLimit]
  byte b_byteMoveIndex
  byte b_RxString[_byteLimit]
  byte b_prefix[_byteLimit]
  byte b_suffix[_byteLimit]


  ' Main cog variables

  long l_localIndex
  long l_localPeriod
  long l_localCamPeriod
  long l_localCrankPeriod
  long l_timeStamp
  long l_currentCam
  long l_previousCam1
  long l_previousCam2
  long l_previousCam3
  long l_previousCam4
  long l_previousCam5
  long l_previousCam6
  long l_trigger1
  long l_trigger2
  long l_trigger3
  long l_currentCrank
  long l_previousCrank1
  long l_previousCrank2
  long l_previousCrank3
  long l_previousCrank4
  long l_previousCrank5
  long l_previousCrank6
  long l_previous5CrankAverage
  long l_elapsedTime
  long l_previousGap
  long l_currentGap
  long l_toothGap
  long l_toothGap1
  long l_toothGap2
  long l_toothGap3
  long l_toothGap4
  long l_toothGap5
  long l_toothGap6
  long l_previousToothGapAverage
  long l_toothGapRpm
  long l_crankToothRpm
  long l_previousNum1
  long l_previousNum2
  long l_previousNum3
  long l_previousNum4
  long l_previousNum5
  long l_previousNum6
  long l_current
  long l_previous5average
  long l_toothRpm

  long l_calculatedCamRpm
  long l_calculatedCrankRpm


  
  long l_frequencyRate
  long l_updateRateDenominator
  long l_pstSimulateCamWheel
  long l_pstSimulateCrankWheel
  long l_pstReadCamWheel
  long l_pstReadCrankWheel
  long l_myReceivedByte
  long l_sendAllValuesOnce
  long l_sendAllValues
  


  long pulserStack[100]
  long simulateCamWheelstack[100]
  long simulateCrankWheelStack[100]
  long comStack[100]


OBJ
  pst : "Parallax Serial Terminal"
  n : "Numbers"
  fcam : "jm_freqin"
  fcrank : "jm_freqin"
  'f : "jm_freqin"



PUB Main | localIndex, localPeriod, localCamPeriod, localCrankPeriod, timeStamp{,{
} currentCam, previousCam1, previousCam2, previousCam3, previousCam4, previousCam5, {
} previousCam6, {trigger1, trigger2, trigger3,} currentCrank,{ previousCrank1, previousCrank2,{
} previousCrank3, previousCrank4, previousCrank5, previousCrank6, previous5CrankAverage,}{
} elapsedTime, previousGap, currentGap{, toothGap, toothGap1, toothGap2, toothGap3, toothGap4, toothGap5,{
} toothGap6}{, previousToothGapAverage, toothGapRpm, crankToothRpm, previousNum1, previousNum2, previousNum3,{
} previousNum4, previousNum5, previousNum6, current, previous5average, toothRpm } } 

  
  
  'cognew(readCrankWheel(19, 34), @readCrankWheelStack)
  'cognew(crankPulser(16, @frequencyRate, 36, 2), @pulserStack)                 ' pulser(pin, pntr, presentTeeth, missingTeeth)
  'cognew(crankPulser(4, @l_frequencyRate, 36, 2), @pulserStack)                   ' for protoboard (send)
  'cognew(readCrankWheel(3, 34), @readCrankWheelStack)                          ' for protoboard (receive)
  'cognew(simulateCamWheel(20, 10000, 2, 1, 106, 216, 5), @simulateCamWheel)                                ' simCam2(simCamWheelPinNum, engineRPM, degreeOfTrigger1, degreeOfTrigger2, degreeOfTrigger3)
  cognew(simulateCamWheel(2, 5000, 2, 100, 100, 145, 5), @simulateCamWheelstack)                  ' for protoboard, staggered triggers
  'cognew(simulateCamWheel(2, 10000, 2, 1, 121, 241, 5), @simulateCamWheel)                  ' for protoboard, equal triggers
  cognew(simulateCrankWheel(4, 36, 2, 5000), @simulateCrankWheelStack)
  cognew(com, @comStack)
  

    
  ' Initialize variables here 
  
  b_delimiter := "="
  
  l_pstSimulateCamWheel := 0    ' Set this to 0 if you don't want to see the pst troubleshooting code lines, 1 if you do
  l_pstReadCamWheel := 1 
  l_pstReadCrankWheel := 1    ' Set this to 0 if you don't want to see the pst troubleshooting code lines, 1 if you do
  l_frequencyRate := 6000           ' 60hz=100rpm, 600hz=1000rpm,6000hz=10000rpm
   
        
  {pst.Start(115_200)
  pst.Clear
  pst.str(string("Beginning"))
  pst.Str(String(pst#NL))}
  

  localIndex := 0
  localPeriod := 0
  localCamPeriod := 0
  localCrankPeriod := 0
  
  

  'f.init(19)                     ' for breadboard, read frequency  
  fcam.init(3)                     ' for protoboard, read frequency
  fcrank.init(5)                     ' for protoboard, read frequency    
  'timeStamp := cnt

  

  repeat


    localCamPeriod := fcam.period

    if(localCamPeriod) <> 0 and l_pstReadCamWheel == 1
      l_calculatedCamRpm := calculateCamRpm(localCamPeriod)

      

    localCrankPeriod := fcrank.period

    if(localCrankPeriod) <> 0 and l_pstReadCrankWheel == 1
      calculateCrankRpm(localCrankPeriod)

    'pst.dec(cnt)      ' loops every 144336 clk cycles at 10k rpm, 137456 at 5k rpm 
    'pst.char(13)   
             

      
        


PUB com | timeStamp

  pst.Start(115_200)
  pst.Clear
  pst.str(string("Beginning"))
  pst.Str(String(pst#NL))

  l_updateRateDenominator := 2
   
  timeStamp := cnt

  repeat

    if((cnt-timeStamp) > (clkfreq/l_updateRateDenominator))
    
      timeStamp := cnt
      pst.Dec(l_toothGapRpm)
      pst.str(string(pst#NL))
      pst.Dec(l_toothRpm)
      pst.str(string(pst#NL))      
      pst.Dec(l_calculatedCamRpm)
      pst.str(string(pst#NL)) 
      pst.str(@b_waitingToBeParsed)
      pst.str(string(pst#NL))
      pst.str(string(pst#NL))  
         
   
    if (l_sendAllValuesOnce == 1)
      if(cnt > (timeStamp + (clkfreq/l_updateRateDenominator))) 
        sendValues
        l_sendAllValuesOnce := 0
   
    if (l_sendAllValues == 1)
      sendValues
           
   
   
    l_myReceivedByte := pst.RxCheck
     
    if l_myReceivedByte <> -1
      b_waitingToBeParsed[b_byteMoveIndex++] := l_myReceivedByte
     
      pst.str(@b_waitingToBeParsed)
      pst.str(string(pst#NL))
     
      if l_myReceivedByte == 13
        DelimiterFinder(@b_waitingToBeParsed)
        ByteFill(@b_waitingToBeParsed, 0, strsize(@b_waitingToBeParsed))
        b_byteMoveIndex := 0    
  

PRI crankPulser(pin, pntr, presentTeeth, missingTeeth) | pulse, sync, timing, localIndex, val, val2

'' Output 1 to 500Hz signal on pin
'' -- high-going pulse is fixed to 1ms
'' -- pntr is hub address of signal frequency (1 to 500Hz)

  ctra := (%00100 << 26) | pin                                  ' setup counter for pin
  frqa := 1
  phsa := 0

  dira[pin] := 1                                                ' make output 

  waitcnt(cnt+clkfreq)
  pulse := clkfreq / 10_000                                      ' ticks in 1ms
  {pst.Dec(pin)
  pst.Str(string("**",pst#NL))
  pst.Dec(presentTeeth)
  pst.Str(string("**",pst#NL))
  pst.Dec(missingTeeth)
  pst.Str(string("**",pst#NL))
  pst.Str(string("**",pst#NL))}

  {val := 6000
  val2 := @val}
  
  sync := cnt                                                   ' sync with system clock  
  repeat
    
    repeat localIndex from 1 to (presentTeeth- missingTeeth)
      phsa := -pulse                                              ' create 1ms pulse
      {timing := long[pntr]
      if (timing =< 0)                                            ' if zero
        timing := 7000                                             '   set to max
      else
        timing <#= 7000}
      timing := clkfreq / 6000'timing                                  ' convert for waitcnt                                      
      waitcnt(sync += timing)                                     ' hold for current hz setting

    
    repeat localIndex from 1 to (missingTeeth)
      'phsa := -pulse                                              ' create 1ms pulse, comment out for flat line pulse
      {timing := long[pntr]
      if (timing =< 0)                                            ' if zero
        timing := 7000                                             '   set to max
      else
        timing <#= 7000}
      timing := clkfreq / 6000'timing                                  ' convert for waitcnt                                     
      waitcnt(sync += timing)

                                                          
                               
PUB simulateCamWheel(simCamWheelPinNum, engineRPM, crankRotsToCamRots, degreeOfTrigger1, degreeOfTrigger2, degreeOfTrigger3, camTriggerDegreeWidth) | localIndex1, crankRpmPerSecond, camRpmPerSecond, localCnt, trigger1Wait, trigger2Wait, trigger3Wait, emtpySpace1Wait, emtpySpace2Wait, emtpySpace3Wait, cyclesPerDegOfRot

  
  
  dira[simCamWheelPinNum]~~
  outa[simCamWheelPinNum]~
  localIndex1 := 0

  crankRpmPerSecond := (engineRPM/60)                   ' 166.667 crank rots per second at 10k rpm
  camRpmPerSecond := (((engineRPM*10)/60)/2)                 ' 83.333 cam rots per second at 10k rpm
  cyclesPerDegOfRot := (((clkfreq/camRpmPerSecond)/360)*10)  ' 960000/360 at 10k or 2660

  trigger1Wait := (camTriggerDegreeWidth*cyclesPerDegOfRot)                     ' 13300 / 5 degrees
  trigger2Wait := (camTriggerDegreeWidth*cyclesPerDegOfRot)                     ' 13300 / 5 degrees
  trigger3Wait := (camTriggerDegreeWidth*cyclesPerDegOfRot)                     ' 13300 / 5 degrees
  emtpySpace1Wait := (degreeOfTrigger1*cyclesPerDegOfRot)                       ' 266000 / 100 degrees
  emtpySpace2Wait := (degreeOfTrigger2*cyclesPerDegOfRot)                       ' 266000 / 100 degrees 
  emtpySpace3Wait := (degreeOfTrigger3*cyclesPerDegOfRot)                       ' 385700 / 145 degrees    
                                                                                ' + = 957600   (((clkfreq/957600) * 60sec/min) * 2rots campercrank) = 10krpm
  {pst.Dec(simCamWheelPinNum)
  pst.Str(string(pst#NL))
  pst.Dec(engineRPM)
  pst.Str(string(pst#NL))
  pst.Dec(crankRotsToCamRots)
  pst.Str(string(pst#NL))
  pst.Str(string(pst#NL))
  pst.Dec(degreeOfTrigger1)
  pst.Str(string(pst#NL))
  pst.Dec(degreeOfTrigger2)
  pst.Str(string(pst#NL))
  pst.Dec(degreeOfTrigger3)
  pst.Str(string(pst#NL))
  pst.Dec(camTriggerDegreeWidth)
  pst.Str(string(pst#NL))
  pst.Str(string(pst#NL))
  pst.Dec(crankRPMPerSecond)
  pst.Str(string(pst#NL))
  pst.Dec(camRPMPerSecond)
  pst.Str(string(pst#NL))
  pst.Dec(cyclesPerDegOfRot)
  pst.Str(string(pst#NL))
  pst.Dec(trigger1Wait)
  pst.Str(string(pst#NL))
  pst.Dec(emtpySpace1Wait)
  pst.Str(string(pst#NL))
  pst.Dec(emtpySpace2Wait)
  pst.Str(string(pst#NL))
  pst.Dec(emtpySpace3Wait)
  pst.Str(string(pst#NL))
  pst.Str(string(pst#NL))}

  localCnt := cnt                                      

  repeat

    outa[simCamWheelPinNum]~~
    waitcnt(localCnt += trigger1Wait)                ' 6665                
    outa[simCamWheelPinNum]~
    'waitcnt(localCnt += (clkfreq/521))                  ' 160000-6665 
    waitcnt(localCnt += emtpySpace1Wait)
    outa[simCamWheelPinNum]~~
    waitcnt(localCnt += trigger2Wait)                ' 6665
    outa[simCamWheelPinNum]~
    'waitcnt(localCnt += (clkfreq/521))                  ' 160000-6665 
    waitcnt(localCnt += emtpySpace2Wait)
    outa[simCamWheelPinNum]~~
    waitcnt(localCnt += trigger3Wait)                ' 6665
    outa[simCamWheelPinNum]~
    'waitcnt(localCnt += (clkfreq/521))                  ' 160000-6665 
    waitcnt(localCnt += emtpySpace3Wait)


PUB simulateCrankWheel(simCrankWheelPinNum, crankTeethSimToothCnt, crankTeethSimMissingToothCnt, crankTeethSimRPM) | localIndex, waitTime, startCnt 
 
  
   ' Initialize variables here 
  dira[simCrankWheelPinNum]~~
  outa[simCrankWheelPinNum]~
  localIndex := 0
  waitTime := (clkfreq/((crankTeethSimRPM*(crankTeethSimToothCnt*2))/60))
  startCnt := cnt

  {ctra := (%00100 << 26) | simCrankWheelPinNum                                  ' setup counter for pin
  frqa := 1                                                                     ' this makes the cnt screw up every 26 seconds                                      
  phsa := 0}

  {
    This is for a Hall effect signal/sensor simulation
    For 1000rpms on a 36-2 crank trigger wheel, it'd be (1000(36*2)) = 72000, then 72000/60 = 1200 teeth on/teeth off per clkfreq. 80000000(clkfreq)/1200 =
    a tooth on or tooth off every 133333.3 clk cycles. It would be on for 66666.67 clk cycles and then was off for every 66666.67 clk cycles  
    So you'd loop on for 66666.67 cycles and then off for 66666.67 cycles and after 34 times, you'd wait for 66666.67 cycles * 4, to simulate the 2
    missing teeth on and accompanying 2 "missing" teeth off (or gaps in between each tooth)
    An example to start the method would be simulateCamWheel(7, 3, 105, 100)
  }
  
 
  repeat
     
    repeat localIndex from 1 to (crankTeethSimToothCnt - crankTeethSimMissingToothCnt)    ' loop number of physical teeth on and off  
      outa[simCrankWheelPinNum]~~
      'l_crankTeethSimOn := startCnt
      waitcnt(startCnt += waitTime)                                                        ' on for 1 tooth
      outa[simCrankWheelPinNum]~
      'l_crankTeethSimOff := startCnt
      waitcnt(startCnt += waitTime)                                                        ' off for 1 tooth
 
    repeat localIndex from 1 to (crankTeethSimMissingToothCnt)                             ' loop number of times for each missing tooth
      outa[simCrankWheelPinNum]~
      'l_crankTeethSimOff := startCnt
      waitcnt(startCnt += waitTime)                                                        ' on for 1 tooth
      outa[simCrankWheelPinNum]~
      'l_crankTeethSimOff := startCnt
      waitcnt(startCnt += waitTime)                                                        ' off for 1 space in between teeth

                                  



PUB calculateCamRpm(localCamPeriod)


  
  if(localCamPeriod) <> 0 and l_pstReadCamWheel == 1 
      l_previousCam6 := l_previousCam5
      l_previousCam5 := l_previousCam4
      l_previousCam4 := l_previousCam3
      l_previousCam3 := l_previousCam2
      l_previousCam2 := l_currentCam
      l_currentCam := localCamPeriod

      
        
      if l_previousCam6 <> 0 and l_previousCam5 <> 0 and l_previousCam4 <> 0 and l_previousCam3 <> 0 and l_previousCam2 <> 0

        {pst.dec(currentCam)
        pst.str(string(pst#NL))
        pst.dec(previousCam2)
        pst.str(string(pst#NL))
        pst.dec(previousCam3)
        pst.str(string(pst#NL))
        pst.dec(trigger2)
        pst.str(string(pst#NL))} 

          ' trigger1/(cba) 
          '              c > b*1.1               and             c  > a*1.1
          if((l_currentCam*100) > (l_previousCam2*110)) and ((l_currentCam*100) > (l_previousCam3*110)) and (l_trigger1 <> true)
            if((l_previousCam2*100) < (l_previousCam3*105)) and ((l_previousCam2*100) > (l_previousCam3*95))  ' b < a*1.1 and b > a*1.1
              l_trigger1 := true
              l_trigger2 := false
              l_trigger3 := false
              
          '  trigger2/(acb)    
          '          a*1.1 < c            
          if((l_currentCam*110) < (l_previousCam2*100)) and (l_trigger2 <> true)
            if(((l_currentCam*100) < (l_previousCam3*105)) and ((l_currentCam*100) > (l_previousCam3*95)))  ' a < b*1.05 and a > b*1.05
              if((l_previousCam2*100) > (l_previousCam3*110)) 'c > b*1.1
                l_trigger2 := true
                l_trigger3 := false
                l_trigger1 := false

          ' trigger3/(bac)      
          '               b < a*1.05              and             b > a*.95                             b*1.1 < c
          if(((l_currentCam*100) < (l_previousCam2*105)) and ((l_currentCam*100) > (l_previousCam2*95))) and ((l_currentCam*110) < (l_previousCam3*100)) and (l_trigger3 <> true) 
            if((l_previousCam2*110) < (l_previousCam3*100)) ' a*1.1 < c
              l_trigger3 := true
              l_trigger1 := false
              l_trigger2 := false

         {pst.dec(l_previousCam6)
         pst.str(string(pst#NL))
         pst.dec(l_previousCam5)
         pst.str(string(pst#NL))
         pst.dec(l_previousCam4)
         pst.str(string(pst#NL))
         pst.dec(l_previousCam3)
         pst.str(string(pst#NL))
         pst.dec(l_previousCam2)
         pst.str(string(pst#NL))
         pst.dec(l_currentCam)
         pst.str(string(pst#NL))}  
         {pst.dec(((clkfreq/((l_currentCam+l_previousCam2+l_previousCam3)/10))*120)/10)
         pst.str(string(pst#NL))}
         
        return(((clkfreq/((l_currentCam+l_previousCam2+l_previousCam3)/10))*120)/10)
                 



PUB calculateCrankRpm(localCrankPeriod)

  if (localCrankPeriod) <> 0 and l_pstReadCrankWheel == 1
      '
    l_previousNum6 := l_previousNum5
    l_previousNum5 := l_previousNum4
    l_previousNum4 := l_previousNum3
    l_previousNum3 := l_previousNum2
    l_previousNum2 := l_current
    l_current := localCrankPeriod  
    {if localCrankPeriod > 20000
      pst.Dec(localCrankPeriod)
      pst.str(string(pst#NL))}
    'count := count+1
    {pst.Dec(l_previousNum6)
    pst.str(string(pst#NL))
    pst.Dec(l_previousNum5)
    pst.str(string(pst#NL))
    pst.Dec(l_previousNum4)
    pst.str(string(pst#NL))
    pst.Dec(l_previousNum3)
    pst.str(string(pst#NL))
    pst.Dec(l_previousNum2)
    pst.str(string(pst#NL))
    pst.Dec(l_current)
    pst.str(string(pst#NL))
    pst.str(string(pst#NL))}
      
    if l_previousNum6 <> 0 and l_previousNum5 <> 0 and l_previousNum4 <> 0 and l_previousNum3 <> 0 and l_previousNum2 <> 0
      l_previous5average := ((l_previousNum6 + l_previousNum5 + l_previousNum4 + l_previousNum3 + l_previousNum2)/5)
       {pst.str(string("not zero"))
       pst.str(string(pst#NL))
       pst.dec(l_previous5average)
       pst.str(string(pst#NL))
       pst.dec(l_current)
       pst.str(string(pst#NL))
       pst.str(string(pst#NL))} 
       {if(current > 20000)
         pst.str(string("!!!!!!!!!!!!!"))
         pst.str(string(pst#NL))} 
      if ((l_current*100) > (l_previous5average * 110)) 'or ((current*100) < (previous5average * 90))
          'current := previousNum5        ' DO NOT COMMENT OUT
          l_current := l_previous5average        ' DO NOT COMMENT OUT
          'l_toothGap := true
          {pst.str(string("true"))
          pst.str(string(pst#NL))}
      'else
        
          'if(l_toothGap == true)
           ' l_toothGap := false
            l_previousGap := l_currentGap
            l_currentGap := ||cnt
            {pst.str(string("true"))
            pst.str(string(pst#NL))}
            if((l_currentGap<>0) and (l_previousGap<>0))
              l_elapsedTime := (l_currentGap - l_previousGap)
              {pst.Dec(||l_elapsedTime)
              pst.str(string(pst#NL))
              pst.str(string(pst#NL))}
              {pst.dec(currentGap)
              pst.str(string(pst#NL))
              pst.dec(previousGap)
              pst.str(string(pst#NL))
              pst.str(string(pst#NL))}
              
              l_toothGap6 := l_toothGap5
              l_toothGap5 := l_toothGap4
              l_toothGap4 := l_toothGap3
              l_toothGap3 := l_toothGap2
              l_toothGap2 := l_toothGap1          
              l_toothGap1 := ||l_elapsedTime
            
            if l_toothGap6 <> 0 and l_toothGap5 <> 0 and l_toothGap4 <> 0 and l_toothGap3 <> 0 and l_toothGap2 <> 0 'and (((clkfreq/((toothGap1-toothGap2)/10))*60)/20) <> 0
                                  
              {pst.Dec(toothGap6)
              pst.str(string(pst#NL))
              pst.Dec(toothGap5)
              pst.str(string(pst#NL))
              pst.Dec(toothGap4)
              pst.str(string(pst#NL))
              pst.Dec(toothGap3)
              pst.str(string(pst#NL))
              pst.Dec(toothGap2)
              pst.str(string(pst#NL))}
              'pst.Dec(toothGap1)
              'pst.str(string(pst#NL))
              'pst.str(string(pst#NL)) 
              'pst.Dec(((clkfreq/((toothGap1-toothGap2)/10))*60)/20)  ' write code here to reject an average lower than x.x
              l_previousToothGapAverage := ((l_toothGap6+l_toothGap5+l_toothGap4+l_toothGap3+l_toothGap2)/5)
              'pst.Dec(previousToothGapAverage)
              'pst.str(string(pst#NL))
              'pst.str(string(pst#NL)) 
              if (((l_toothGap1/10)*100) > ((l_previousToothGapAverage/10)*110)) or (((l_toothGap1/10)*100) < ((l_previousToothGapAverage/10)*90))
                l_toothGap1 := l_previousToothGapAverage
                'pst.str(string("*** "))
                'pst.Dec(toothGap1)
                'pst.str(string(pst#NL))
           
              else
                {pst.Dec(((clkfreq/((previousToothGapAverage)/100))*60)/100)
                pst.str(string(pst#NL))
                pst.str(string(pst#NL))}
                l_toothGapRpm := (((clkfreq/((l_previousToothGapAverage)/100))*60)/100)  
              
      else         
        
        
        if (((clkfreq/l_current)*60)/36) < 90
            {pst.Dec(l_previousNum6)
            pst.str(string(pst#NL))
            pst.Dec(l_previousNum5)
            pst.str(string(pst#NL))
            pst.Dec(l_previousNum4)
            pst.str(string(pst#NL))
            pst.Dec(l_previousNum3)
            pst.str(string(pst#NL))
            pst.Dec(l_previousNum2)
            pst.str(string(pst#NL))
            pst.Dec(l_current)
            pst.str(string(pst#NL))
            pst.Dec(((clkfreq/l_current)*60)/36)
            pst.str(string(pst#NL, pst#NL)) }
            
        else
            'pst.Dec(((clkfreq/current)*60)/36)
            {pst.Dec(((clkfreq/previous5average)*60)/36)
            pst.str(string(pst#NL))}
            l_toothRpm := (((clkfreq/l_previous5average)*60)/36)
            {pst.Dec(l_toothRpm)
            pst.str(string(pst#NL))} 

            



PUB elapsed_time_msec(p_TimeVar) | RightNow, ClockTicks
'can measure up to 26843 Milliseconds
'(2147483647 CounterTicks / 80.000.000 Hz = 26843 Milliseconds) 

  RightNow := cnt

  if RightNow < p_TimeVar                          
    ClockTicks := ||($FFFFFFFF - RightNow + p_TimeVar)  
  else
    ClockTicks := ||(RightNow - p_TimeVar)

  result := ClockTicks / (clkfreq / 1_000) 'calculate milliseconds


  '################################################################################
  'explanation how it works
  ' SPIN treats longs as SIGNED longs this means bit-No 32 represents the sign "+-"
  ' the systemcounter thinks of the 32bits as UNsigned meaning bit 32 is
  ' just another bit of the number and NOT a sign "+-" 
  ' if one or both values are negative it could happen
  ' that the result is negative too
  ' the command "||" calculates the absolute value of the SIGNED longs

  'even if the systemcounter has wrapped around since the snapshot of
  'systemcounter (value of parameter p_TimeVar),
  'this method calculates the timedifference in the right way
  
  'wrap-around example with easy numbers: counter maxvalue 1000
  'p_TimeVar containing value 980
  'time goes on counter wraps around from 1000 to 0
  'time goes on 
  'RightNow containing 300. This means 20 ticks until maximum 1000 and 300 ticks
  'since wrapping from 1000 to 0 in summary 320 ticks of time has gone
  'this is calculated by MaxCounter - p_TimeVar + RightNow
  'in numbers              1000     -   980     +   300     = 320
  'the real systemcounter has 32bits max value 2^32 -1 = 4294967295
  'hexadecimal $FFFFFFFF
  '################################################################################
 
'end of PUB elapsed_time_msec(p_TimeVar) | RightNow, ClockTicks


PUB DelimiterFinder(RxStringAddr) : idx | localCount, localIndex, pstDelimiterFinder                                            

  ' Initialize variables here
  localIndex := 0
  pstDelimiterFinder := 0

  repeat
    ifnot localCount := byte[RxStringAddr][idx++]                ' ifnot c, itterate to the next byte in byte[RxStringAddr] ?
      pst.Str(String("No delimiter, aborted"))
      pst.str(string(pst#NL))
      return -1

    pst.char(localCount)
    pst.str(string(pst#NL))  
  until localCount == b_delimiter'localCount == "="
 
  bytemove(@b_prefix, RxStringAddr, --idx)              ' idx points to the character after the delimiter, copy prefix
  b_prefix[idx] := 0                                    ' add terminator  
  RxStringAddr += idx + 1                               ' advance pointer, skip delimiter (+1)                                                 
  bytemove(@b_suffix, RxStringAddr, strsize(RxStringAddr) +1)                   ' copy tail including the existing terminator (+1)
  variableUpdator(@b_prefix, @b_suffix)




PUB variableUpdator(preAddr, sufAddr) | localIndex, pstVariableUpdator   ' variableUpdator(@prefix, @suffix)

  ' Initialize variables here
  localIndex := 0
  pstVariableUpdator := 0

  if strcomp(preAddr, string("updateRateDenominator")) 'strcomp(@prefix, var1)
    
    l_updateRateDenominator := n.FromStr(sufAddr, %000_000_000_0_0_000000_01010) ' n.FromStr(@suffix, %000_000_000_0_0_000000_01010)    ' converts from a string to a dec
    pst.str(l_updateRateDenominator)
    pst.str(string(pst#NL))

  if strcomp(preAddr, string("sendAllValuesOnce")) 'strcomp(@prefix, var1)
    
    l_sendAllValuesOnce := n.FromStr(sufAddr, %000_000_000_0_0_000000_01010) ' n.FromStr(@suffix, %000_000_000_0_0_000000_01010)    ' converts from a string to a dec
    pst.str(l_sendAllValuesOnce)
    pst.str(string(pst#NL))

  if strcomp(preAddr, string("sendAllValues")) 'strcomp(@prefix, var1)
    
    l_sendAllValues := n.FromStr(sufAddr, %000_000_000_0_0_000000_01010) ' n.FromStr(@suffix, %000_000_000_0_0_000000_01010)    ' converts from a string to a dec
    pst.str(l_sendAllValues)
    pst.str(string(pst#NL))    
    
  {if strcomp(preAddr, l_i1Name) 'strcomp(@prefix, var1)
    
    l_i1value := n.FromStr(sufAddr, %000_000_000_0_0_000000_01010) ' n.FromStr(@suffix, %000_000_000_0_0_000000_01010)    ' converts from a string to a dec


    long sendAllValuesOnce
  long sendAllValues



  
     }





PUB sendValues | localIndex, pstSendAllValues

  ' Initialize variables here
  localIndex := 0
  pstSendAllValues := 0 

  pst.Str(String("sendAllValues()", pst#NL))

    
         